---
author: Crabmeat
date: 2025-06-09
gitea_url: "http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/344"
xmr: 89aWkJ8yabjWTDYcHYhS3ZCrNZiwurptzRZsEpuBLFpJgUfAK2aj74CPDSNZDRnRqeKNGTgrsi9LwGJiaQBQP4Yg5YtJw2U 
---
# **Protesting is not enough**

## **Why are people protesting?** 

All around the world, people protest when they want political change. In some countries, protests have been suppressed by military forces or militias deployed by the government, but in general, protesting remains the most common way for people to demand changes from the state. But why is this the preferred method instead of others?

At its core, protesting is essentially a nonviolent way of trying to obtain something you want from someone. In many cases, violence can escalate quickly during protests, but it is often the result of external factors, such as violence initiated by government forces.

People tend to think that protesting is an effective way to get the authorities’ attention without facing any major consequences. In reality, as we will see later, no one is truly listened to while protesting.

Sometimes, protesters choose to resort to violence in an attempt to strengthen their message. However, in any case, the fight is never balanced against the governments in power, and this often only makes things worse.

Another reason people choose protest over other methods of seeking change is its visibility. Public demonstrations can attract media attention and, in some cases, pressure governments into responding to demands. In reality, however, the media is often influenced—or even controlled—by governments, meaning protests may receive little or biased coverage.

On the other hand, protesting is widely seen as a fundamental right by people living in so-called “democracies,” and many hope it will bring about change. As we discussed in our [article](http://blog.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/opsec/stateistheenemy/) titled The State is the Enemy, democracy often resembles an illusion more than a reality in many countries that claim the label.

![](protest.png)

## **Examples of useless protests around the world**

I'd like to share some examples of protests from around the world that either failed to bring about any change or ended up making the situation worse.

1) The Tiananmen Square Protests (China, 1989)

What Happened: Students and civilians protested in Beijing, calling for political change, particularly regarding personal freedoms and government corruption.

Outcome: The Chinese government responded with martial law and a brutal suppression of the protests. Thousands of people were killed or arrested, and the government became even more authoritarian. These events are still heavily censored in China.

Here is the [Wikipedia](https://en.wikipedia.org/wiki/1989_Tiananmen_Square_protests_and_massacre) page that relates this events. 

![](tiananmen.png)

2) The Yellow Vest Protests (France, 2018-2019)

What Happened: The protests started after the announcement of a fuel tax increase, but the protesters quickly expanded their demands to include opposition to economic inequality and government policies. The main method of protest was to pacefuly block streets and roads across the country.

Outcome: The protests failed to bring about the systemic changes that the protesters had hoped for. As violence escalated, driven by the government's lack of engagement, public support for the movement waned. In response, the government decided to use force against the protesters. Many people were injured by police, including independent journalists who were attempting to cover the events.

Here is the [Wikipedia](https://en.wikipedia.org/wiki/Yellow_vests_protests) page relating this events. 

![](yellow.png)

Under Emmanuel Macron's reign, many unpopular reforms were presented to the public, leading to widespread protests. Here is a list of the major reforms passed using Article 49.3 (which allows the government to pass legislation without a parliamentary vote, bypassing opposition):

*Labor Market Reform (2017)*

Law Name: Loi Travail (Labor Law Reform)
Date: September 2017
Explanation: This reform aimed to make France’s labor market more flexible by allowing companies to negotiate directly with employees (bypassing national labor unions) and simplifying the rules around layoffs. It was said it was designed to encourage hiring and improve competitiveness but faced widespread opposition, particularly from trade unions.

*Pension Reform (2019-2020)*

Law Name: Réforme des Retraites (Pension Reform)
Date: March 2020 (after a long period of debate and protests)
Explanation: Macron’s government aimed to overhaul France’s complex pension system by implementing a universal points-based system. This would have replaced the 42 existing pension schemes with one single system. The reform was highly controversial and led to massive strikes and protests, particularly among public sector workers. The main protest reason was that it involved working longer than usual. (Until 67 years old VS 65 years old)

*2020 Social Security Budget (Health & Social Spending)*

Law Name: Loi de Financement de la Sécurité Sociale 2020 (2020 Social Security Finance Law)
Date: December 2019
Explanation: This annual law set the framework for the financing of France’s social security system, addressing deficits in healthcare and other areas. It was passed under 49.3 to quickly manage increasing spending due to healthcare demands.

*2020 Emergency Law for Covid-19*

Law Name: Loi d'Urgence pour Faire Face à l'Épidémie de Covid-19 (Covid-19 Emergency Law)
Date: March 2020
Explanation: With the Covid-19 crisis unfolding, Macron’s government passed emergency measures using 49.3 to implement a national lockdown, introduce quarantine protocols, and provide economic support to businesses and workers impacted by the pandemic. Most of the reform was considered as hostile to freedom by the population. 

*2020 Rectified Finance Law (Covid-19 Economic Response)*

Law Name: Loi de Finances Rectificative 2020 (Rectified Finance Law 2020)
Date: July 2020
Explanation: This law was aimed at addressing the economic fallout from the Covid-19 crisis, providing significant financial support to businesses, workers, and the healthcare sector. It included measures for loans, subsidies, and economic recovery plans. Most of opponents argued that it would cause an economic nightmare in the country, and it did. 

![](493.png)

*2022 Security Law*

Law Name: Loi Sécurité Globale (Global Security Law)
Date: November 2020
Explanation: This controversial law expanded police powers, including the right to control video footage of police actions, and introduced stricter regulations around demonstrations. Critics argued it could lead to increased surveillance and curb press freedoms. It was fiercely opposed by civil rights groups.

*2022 Budget Law*

Law Name: Loi de Finances 2022 (2022 Finance Law)
Date: October 2021
Explanation: The national budget for 2022, which included tax cuts, increased spending on public services, and provisions for dealing with inflation and rising energy costs, was passed under 49.3 due to the lack of a parliamentary majority after Macron's party lost seats in the 2022 elections.

*2022 Covid-19 Health Pass Law*

Law Name: Loi sur le Pass Sanitaire (Health Pass Law)
Date: July 2021
Explanation: To combat the Covid-19 pandemic, this law mandated the use of a health pass for individuals wishing to access certain public spaces, including restaurants, theaters, and long-distance travel. It was heavily criticized by anti-vaxxers and others as an infringement on personal freedoms.

*2022 Energy Law*

Law Name: Loi Climat et Résilience (Climate and Resilience Law)
Date: July 2021
Explanation: This law aimed to combat climate change by reducing carbon emissions and promoting renewable energy. It included measures to improve energy efficiency, promote public transportation, and ban certain plastic products. The law was passed quickly to meet EU climate targets.

*2023 Budget Law*

Law Name: Loi de Finances 2023 (2023 Finance Law)
Date: December 2022
Explanation: The 2023 budget, which included measures to tackle inflation, reduce public debt, and enhance public spending on various sectors, was passed using 49.3 due to political gridlock in the National Assembly, following Macron's loss of a parliamentary majority in the 2022 legislative elections.

All these examples show that governments often act against the will of the population, even in the face of mass protests. They can force through any reform simply by invoking Article 49.3. Since this article is part of the Constitution, it essentially provides a legal framework for bypassing both parliamentary debate and public opinion — making it constitutionally acceptable to ignore the voice of the people. And as you can see, the changes imposed by the French government were truly life-altering for the population.

3) The Arab Spring (Various countries in the Middle East and North Africa, 2010-2012)

What Happened: The Middle East and North Africa were shaken by a wave of protests demanding better living conditions and the end of authoritarian rule.

Outcome: In many cases, the consequances of these uprisings were chaotic and violent. While some countries, like Tunisia, made strides toward democracy, others, such as Libya and Syria, descended into civil war. In many cases, authoritarian regimes were replaced with instability, violence, and ongoing human rights abuses.

Here is the [Wikipedia](https://en.wikipedia.org/wiki/Arab_Spring) page relating this events. 

![](arabspring.png)

4) The 2013 Brazilian Protests (Brazil)

What Happened: Initially sparked by a rise in public transport fares, the protests in Brazil quickly morphed into demonstrations against corruption, poor public services, and government spending priorities.

Outcome: The protests led to the government reversing the transport fare hikes, but little was done to address the root causes of the unrest, such as corruption and inequality. As a result, the protests did not lead to lasting changes, and political instability grew in the years following, culminating in the impeachment of President Dilma Rousseff in 2016.

Here is the [Wikipedia](https://en.wikipedia.org/wiki/2013_protests_in_Brazil) page about this events. 

![](brazil.png)

These examples show that even large protests, whether violent or non-violent and often supported by a significant portion of the population, rarely lead to the expected outcomes. Protest is an ancient method of resistance, but it is no longer an effective strategy today, as the balance of power between the population and government forces is deeply skewed. Governments have the legal authority to use force against citizens, while protesting itself can be deemed illegal. It’s nearly impossible to win against an institution that can deploy an army to control crowds, simply through protesting.

![](deadlyprotests.png)

As the media are often influenced or controlled by governments, public support can also be manipulated: 

![](perception.png)

## **So, what's the solution?**

As we've seen, protesting is no longer an effective strategy against governments that don't hesitate to harm or even kill their citizens, all while being protected by the very laws they create. So, what is the solution?

The solution is to render governments completely ineffective. If we can strip them of all their power by completely stepping outside their system, they will collapse on their own.

To make governments irrelevant, it's necessary to build an alternative system outside of the existing one—starting with a parallel economy, since the economy is what primarily sustains governments. If people stop allowing them to take their money and succeed in making government decisions meaningless in their lives, it would gradually choke the system and render it powerless.

![](parallel.png)

To achieve this, people need to live without paying taxes. You must be compensated for your work in a currency that is not controlled by states. For example, [Monero](https://en.wikipedia.org/wiki/Monero) (XMR) is a cryptocurrency that operates independently of any government control and ensures that your transactions are untraceable. 

If you keep your transactions secret and stay off the radar, and if you work hard to maintain your anonymity online—following the advice shared in this blog, for example—you’ll be much more effective than just protesting. Governments survive only because they’re siphoning money from the population. By stopping this racket, you stop feeding the institutions that are taking advantage of you.

The goal is to take what you want, not wait for it to come to you.

Our [article](http://blog.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/opsec/agorism/) "What is Agorism", written by the fantastic Sam Bent, is describing it as "Agorism is a form of economic guerrilla warfare against the state. Samuel Edward Konkin III developed this revolutionary philosophy in the 1970s as a strategy that rejects both the futility of political reform and the self-defeating nature of violent revolution. Instead of begging for freedom or fighting for it, agorists build it through direct economic action that makes the state irrelevant.". That's what we are trying to describe here. Here is the illustration used to describe it: 

![](agorism.png)

In addition, creating small, self-sustaining communities independent of government control could help promote shared values such as sustainability, self-reliance, and decentralized governance. These communities could establish education systems that operate outside of traditional, government-controlled institutions. This could involve community-based learning, unschooling, and homeschooling models.

Openware.com publised an interresting [article](https://www.openware.com/news/articles/overview-of-decentralized-communities) bout decentralized communities and how to build it. 

![](screencomunities.png)

In order to help people stay informed about world events without external influence, we need to create decentralized media platforms, with independent journalists, bloggers, and activists. Access to information should not depend on government decisions, which is why such communities must find ways to sustain basic needs outside of the current system—where food, water, electricity, and medicine are often controlled by governments that profit from them.

The following [article](https://techbullion.com/independent-media-and-the-rise-of-alternative-news-platforms/) covers how independent medias are starting to rise. 

![](screenmedia.png)

Developing collaborative, peer-to-peer networks for sharing resources, services, aid, and knowledge—bypassing traditional hierarchical structures—would significantly reduce the power of the state.

Renewable energy projects, led by independent thinkers outside the current system, would help these communities become entirely self-sufficient. Encouraging individuals and communities to become energy-independent by using renewable energy sources like solar, wind, and hydro power would lessen reliance on national grids and energy companies, which are often controlled by both governments and corporations.

This [article](https://www.power-and-beyond.com/ten-of-the-worlds-largest-renewable-energy-projects-a-1bbd49e672adb3070f0b14207f506003/) list the ten of the worlds largest renewable energy projects that could help independent comunities. 

![](screenenergy.png)

Perhaps one of the most important aspects of building independent communities is developing a new social contract. This would allow communities to define their own rules, structures, and systems without government oversight. This can include setting up community councils, cooperatives, and governance systems based on mutual aid and voluntary participation.

If you want additional information about social contract, please refer to this [Wikipedia](https://en.wikipedia.org/wiki/Social_contract) page that explains everything about it. 

As you can see, fighting against governments can't be done simply through protesting—it requires organization and teamwork. And that’s the key point to understand. Just like protesting, building a system outside of the system requires multiple people working together. Competent and knowledgeable individuals need to come together to build what could be the future of humanity.

In his [article](http://blog.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/opsec/agorism/) Sam is illustrating the power of this actions in the section "The Endgame". 

## Real life examples

Some projects and actions have been successfully implemented based on the idea of creating a system outside of the system, and they can serve as inspiration for us:

Many people use cryptocurrency for transactions in countries with unstable currencies, or to avoid government surveillance of their financial activities. As an example, [xmrbazaar](https://xmrbazaar.com/) is a market only using Monero. 

![](screenxmr.png)

The Bristol Pound (UK) and the Bristol Pound Community Bank are examples where local businesses and residents use a currency that is not tied to the central banking system. You can find more details about it [here](https://en.wikipedia.org/wiki/Bristol_pound)

The [Findhorn](https://en.wikipedia.org/wiki/Findhorn_Foundation) Foundation in Scotland is an intentional community that focuses on environmental sustainability and spiritual growth, while the [Damanhur](https://en.wikipedia.org/wiki/Federation_of_Damanhur) community in Italy is based on collective living and a decentralized governance structure.

Obviously, the Dark Web is an example where individuals engage in anonymous activities, often using decentralized platforms like Tor to avoid surveillance and censorship. It is a place of freedom where governments watch is not accepted. But, if you are here, you already know that! 

Linux is an open-source operating system developed collaboratively by a global community of developers, and Wikipedia is a user-generated, open-access resource that runs outside of corporate control. This examples are showing that the union of people sharing values can create protjects laregly used. 

Detroit’s Urban Farming Movement includes community-led efforts to grow food on vacant city lots, reducing dependency on commercial agriculture and government-run food programs. If you want to learn more about this program, the following [article](https://efarmer.com/2025/01/27/urban-farming-in-detroit-a-story-of-resilience-and-renewal/) should help you. 

![](screendetroit.png)

The Herbalism Network and other alternative medicine communities allow people to practice and share traditional healing methods without reliance on government health systems.

Based on this, as small and larger individual projects succeed, we can assume that with a bit of organization, these practices can be combined to create a global system outside of the system. Of course, it can't be done in a day, but sharing information, raising awareness, training people, and recruiting the right individuals would accelerate the process.

Please refer to Sam's [article](http://blog.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/opsec/agorism/), in the chapter "Historical Examples That Prove It Works" to find more examples where Agorsim worked. 

## **Conclusion** 

As we've seen, protesting alone is not enough; we need to hit the states where it hurts — through the economy. By becoming independent and self-sufficient, we can render them useless and weak. I typically reference many books when writing an article, but this time, there's one book that covers it all: Atlas Shrugged by Ayn Rand. If you're looking for a mind-changing book that will open your eyes to a whole new world of subversion, take a look at it.

![](atlas.png)

[Here](https://en.wikipedia.org/wiki/Atlas_Shrugged)’s more information about this masterpiece. 